const util = require('../../../utils/util.js')

/* 手机 验证码 相关内容 */
const BindAccount = {
  /* 跳转 手机登录 */
  phoneLogin: function () { this.setData({ 'bindaccount.isShow': "" }); this.setData({ 'bindphone.isShow': "on" }); },

  /* 账号输入 离开 input blur事件监听 */
  inputAccount: function (e) { this.setData({ 'bindaccount.account': e.detail.value }); },
  /* 密码输入 离开 input blur事件监听 */
  inputPwd: function (e) { this.setData({ 'bindaccount.pwd': e.detail.value }); },
  
  /* 点击确定 */
  accountConfirm: function (e) {
    const _that = this, _bind = _that.data.bindaccount
    /* 调用接口 - 使用账号登录 */
    wx.request({
      url: util.config.URL_PATH + '/user/account-login',
      data: { username: _bind.account, password: _bind.pwd }, method: 'POST', header: { skey: wx.getStorageSync('userSession').sessionKey, tenant: util.config.tenant },
      success: function (res) {
        if (res.statusCode && res.statusCode != 200) { wx.showToast({ title: res.data.message, icon: 'none' }); return; }
        wx.hideToast()
        /* 获取用户信息 */
        wx.request({
          url: util.config.URL_PATH + '/user/getinfo',
          data: {}, method: 'GET', header: {
            skey: wx.getStorageSync('userSession').sessionKey,
            tenant: util.config.tenant
          },
          success: res => {
            if (res.statusCode != 200) { wx.showToast({ title: res.data.message, icon: 'none' }); return; }
            let _userInfo = {
              avatarUrl: res.data.avatar || _that.tempUserInfo.avatarUrl || '无',
              nickName: res.data.nickname || _that.tempUserInfo.nickName || '无'
            }
            wx.setStorageSync('userInfo', _userInfo);
            _that.setData({ userInfo: _userInfo, hasUserInfo: true })
            _that.popupClose()
            _that.goOutSite()
          }
        })
      },
      fail: function (res) { wx.hideToast(); wx.showToast({ title: res, icon: 'none' }); }
    })
  }
}

module.exports = {
  BindAccount: BindAccount,
}